Index: issm/trunk/src/c/parallel/ControlInitialization.cpp
===================================================================
--- issm/trunk/src/c/parallel/ControlInitialization.cpp	(revision 3566)
+++ issm/trunk/src/c/parallel/ControlInitialization.cpp	(revision 3567)
@@ -60,9 +60,9 @@
 
 	/*recover fem models: */
-	fem_dh=model->GetFormulation(DiagnosticAnalysisEnum(),HorizAnalysisEnum());
-	fem_dv=model->GetFormulation(DiagnosticAnalysisEnum(),VertAnalysisEnum());
-	fem_ds=model->GetFormulation(DiagnosticAnalysisEnum(),StokesAnalysisEnum());
-	fem_dhu=model->GetFormulation(DiagnosticAnalysisEnum(),HutterAnalysisEnum());
-	fem_sl=model->GetFormulation(SlopecomputeAnalysisEnum());
+	fem_dh=model->GetFormulation(DiagnosticAnalysisEnum,HorizAnalysisEnum);
+	fem_dv=model->GetFormulation(DiagnosticAnalysisEnum,VertAnalysisEnum);
+	fem_ds=model->GetFormulation(DiagnosticAnalysisEnum,StokesAnalysisEnum);
+	fem_dhu=model->GetFormulation(DiagnosticAnalysisEnum,HutterAnalysisEnum);
+	fem_sl=model->GetFormulation(SlopecomputeAnalysisEnum);
 
 	//specific parameters for specific models
@@ -81,6 +81,6 @@
 	//compute slopes
 	if(verbose)_printf_("%s\n","computing bed slope (x and y derivatives)...");
-	diagnostic_core_linear(&slopex,fem_sl,inputs,SlopecomputeAnalysisEnum(),BedXAnalysisEnum());
-	diagnostic_core_linear(&slopey,fem_sl,inputs,SlopecomputeAnalysisEnum(),BedYAnalysisEnum());
+	diagnostic_core_linear(&slopex,fem_sl,inputs,SlopecomputeAnalysisEnum,BedXAnalysisEnum);
+	diagnostic_core_linear(&slopey,fem_sl,inputs,SlopecomputeAnalysisEnum,BedYAnalysisEnum);
 	FieldExtrudex( slopex, fem_sl->elements,fem_sl->nodes,fem_sl->vertices,fem_sl->loads,fem_sl->materials,fem_sl->parameters,"slopex",0);
 	FieldExtrudex( slopey, fem_sl->elements,fem_sl->nodes,fem_sl->vertices,fem_sl->loads,fem_sl->materials,fem_sl->parameters,"slopey",0);
@@ -95,5 +95,5 @@
 	//horizontal velocity
 	if(verbose)_printf_("%s\n"," computing horizontal velocities...");
-	diagnostic_core_nonlinear(&ug,NULL,NULL,NULL,fem_dh,inputs,DiagnosticAnalysisEnum(),HorizAnalysisEnum());
+	diagnostic_core_nonlinear(&ug,NULL,NULL,NULL,fem_dh,inputs,DiagnosticAnalysisEnum,HorizAnalysisEnum);
 	if(verbose)_printf_("%s\n"," extruding horizontal velocities...");
 	VecDuplicatePatch(&ug_horiz,ug); FieldExtrudex( ug_horiz,fem_dh->elements,fem_dh->nodes, fem_dh->vertices,fem_dh->loads,fem_dh-> materials,fem_dh->parameters,"velocity",1);
@@ -102,5 +102,5 @@
 	if(verbose)_printf_("%s\n"," computing vertical velocities...");
 	inputs->Add("velocity",ug_horiz,numberofdofspernode_dh,numberofnodes);
-	diagnostic_core_linear(&ug_vert,fem_dv,inputs,DiagnosticAnalysisEnum(),VertAnalysisEnum());
+	diagnostic_core_linear(&ug_vert,fem_dv,inputs,DiagnosticAnalysisEnum,VertAnalysisEnum);
 
 	//Create 3d u_g
@@ -113,5 +113,5 @@
 	//Create 4d u_g
 	if(verbose)_printf_("%s\n"," computing pressure according to Pattyn...");
-	ComputePressurex( &pg,fem_dh->elements, fem_dh->nodes, fem_dh->vertices,fem_dh->loads,  fem_dh->materials, fem_dh->parameters,inputs,DiagnosticAnalysisEnum(),HorizAnalysisEnum());
+	ComputePressurex( &pg,fem_dh->elements, fem_dh->nodes, fem_dh->vertices,fem_dh->loads,  fem_dh->materials, fem_dh->parameters,inputs,DiagnosticAnalysisEnum,HorizAnalysisEnum);
 	VecScale(pg,1.0/stokesreconditioning);
 	ug_stokes=NewVec(fem_ds->nodesets->GetGSize());
@@ -133,5 +133,5 @@
 	if(verbose)_printf_("%s\n"," computing stokes velocities and pressure ...");
 	VecFree(&ug);
-	diagnostic_core_nonlinear(&ug,NULL,NULL,NULL,fem_ds,inputs,DiagnosticAnalysisEnum(),StokesAnalysisEnum());
+	diagnostic_core_nonlinear(&ug,NULL,NULL,NULL,fem_ds,inputs,DiagnosticAnalysisEnum,StokesAnalysisEnum);
 
 	//Add in inputs
Index: issm/trunk/src/c/parallel/ControlRestart.cpp
===================================================================
--- issm/trunk/src/c/parallel/ControlRestart.cpp	(revision 3566)
+++ issm/trunk/src/c/parallel/ControlRestart.cpp	(revision 3567)
@@ -34,5 +34,5 @@
 	for(i=0;i<numberofnodes;i++) param_g_copy[i]=param_g[i];
 
-	temporary_results=new DataSet(ResultsEnum()); 
+	temporary_results=new DataSet(ResultsEnum); 
 	result=new Result(temporary_results->Size()+1,0,1,"param_g",param_g_copy,numberofnodes);
 	temporary_results->AddObject(result);
@@ -42,5 +42,5 @@
 
 	//process results
-	ProcessResults(&results,temporary_results,model,ControlAnalysisEnum());
+	ProcessResults(&results,temporary_results,model,ControlAnalysisEnum);
 
 	//Write results on disk
Index: issm/trunk/src/c/parallel/ProcessResults.cpp
===================================================================
--- issm/trunk/src/c/parallel/ProcessResults.cpp	(revision 3566)
+++ issm/trunk/src/c/parallel/ProcessResults.cpp	(revision 3567)
@@ -109,5 +109,5 @@
 
 	/*Initialize new results: */
-	newresults=new DataSet(ResultsEnum());
+	newresults=new DataSet(ResultsEnum);
 	
 	/*some flags needed: */
@@ -118,26 +118,26 @@
 
 	/*Recover femmodels first: */
-	fem_dh=model->GetFormulation(DiagnosticAnalysisEnum(),HorizAnalysisEnum());
+	fem_dh=model->GetFormulation(DiagnosticAnalysisEnum,HorizAnalysisEnum);
 	fem_c=fem_dh;
-	fem_dv=model->GetFormulation(DiagnosticAnalysisEnum(),VertAnalysisEnum());
-	fem_ds=model->GetFormulation(DiagnosticAnalysisEnum(),StokesAnalysisEnum());
-	fem_dhu=model->GetFormulation(DiagnosticAnalysisEnum(),HutterAnalysisEnum());
-	fem_sl=model->GetFormulation(SlopecomputeAnalysisEnum());
-	if(analysis_type==PrognosticAnalysisEnum()){
-		fem_p=model->GetFormulation(PrognosticAnalysisEnum());
+	fem_dv=model->GetFormulation(DiagnosticAnalysisEnum,VertAnalysisEnum);
+	fem_ds=model->GetFormulation(DiagnosticAnalysisEnum,StokesAnalysisEnum);
+	fem_dhu=model->GetFormulation(DiagnosticAnalysisEnum,HutterAnalysisEnum);
+	fem_sl=model->GetFormulation(SlopecomputeAnalysisEnum);
+	if(analysis_type==PrognosticAnalysisEnum){
+		fem_p=model->GetFormulation(PrognosticAnalysisEnum);
 	}
-	if(analysis_type==Prognostic2AnalysisEnum()){
-		fem_p=model->GetFormulation(Prognostic2AnalysisEnum());
+	if(analysis_type==Prognostic2AnalysisEnum){
+		fem_p=model->GetFormulation(Prognostic2AnalysisEnum);
 	}
-	if(analysis_type==TransientAnalysisEnum()){
-		fem_p=model->GetFormulation(PrognosticAnalysisEnum());
+	if(analysis_type==TransientAnalysisEnum){
+		fem_p=model->GetFormulation(PrognosticAnalysisEnum);
 	}
-	if(analysis_type==BalancedthicknessAnalysisEnum()){
-		fem_p=model->GetFormulation(BalancedthicknessAnalysisEnum());
+	if(analysis_type==BalancedthicknessAnalysisEnum){
+		fem_p=model->GetFormulation(BalancedthicknessAnalysisEnum);
 	}
-	if(analysis_type==BalancedvelocitiesAnalysisEnum()){
-		fem_p=model->GetFormulation(BalancedvelocitiesAnalysisEnum());
+	if(analysis_type==BalancedvelocitiesAnalysisEnum){
+		fem_p=model->GetFormulation(BalancedvelocitiesAnalysisEnum);
 	}
-	fem_t=model->GetFormulation(ThermalAnalysisEnum());
+	fem_t=model->GetFormulation(ThermalAnalysisEnum);
 
 	for(n=0;n<results->Size();n++){
Index: issm/trunk/src/c/parallel/balancedthickness.cpp
===================================================================
--- issm/trunk/src/c/parallel/balancedthickness.cpp	(revision 3566)
+++ issm/trunk/src/c/parallel/balancedthickness.cpp	(revision 3567)
@@ -76,5 +76,5 @@
 
 	_printf_("read and create finite element model:\n");
-	model->AddFormulation(fid,BalancedthicknessAnalysisEnum());
+	model->AddFormulation(fid,BalancedthicknessAnalysisEnum);
 
 	/*recover parameters: */
@@ -84,7 +84,7 @@
 	_printf_("initialize inputs:\n");
 	
-	model->FindParam(&u_g_serial,NULL,NULL,"u_g",BalancedthicknessAnalysisEnum());
-	model->FindParam(&melting_g,NULL,NULL,"m_g",BalancedthicknessAnalysisEnum());
-	model->FindParam(&accumulation_g,NULL,NULL,"a_g",BalancedthicknessAnalysisEnum());
+	model->FindParam(&u_g_serial,NULL,NULL,"u_g",BalancedthicknessAnalysisEnum);
+	model->FindParam(&melting_g,NULL,NULL,"m_g",BalancedthicknessAnalysisEnum);
+	model->FindParam(&accumulation_g,NULL,NULL,"a_g",BalancedthicknessAnalysisEnum);
 	model->FindParam(&numberofnodes,"numberofnodes");
 	
@@ -95,5 +95,5 @@
 
 	_printf_("initialize results:\n");
-	results=new DataSet(ResultsEnum());
+	results=new DataSet(ResultsEnum);
 	MPI_Barrier(MPI_COMM_WORLD); finish_init=MPI_Wtime();
 
@@ -115,5 +115,5 @@
 		#ifdef _HAVE_DAKOTA_ 
 		MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
-		Qmux(model,inputs,BalancedthicknessAnalysisEnum(),NoneAnalysisEnum());
+		Qmux(model,inputs,BalancedthicknessAnalysisEnum,NoneAnalysisEnum);
 		MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
 	 	#else
@@ -127,5 +127,5 @@
 	
 	_printf_("process results:\n");
-	ProcessResults(&processedresults,results,model,BalancedthicknessAnalysisEnum());
+	ProcessResults(&processedresults,results,model,BalancedthicknessAnalysisEnum);
 	
 	_printf_("write results to disk:\n");
Index: issm/trunk/src/c/parallel/balancedthickness_core.cpp
===================================================================
--- issm/trunk/src/c/parallel/balancedthickness_core.cpp	(revision 3566)
+++ issm/trunk/src/c/parallel/balancedthickness_core.cpp	(revision 3567)
@@ -35,5 +35,5 @@
 
 	/*recover fem model: */
-	fem_p=model->GetFormulation(BalancedthicknessAnalysisEnum());
+	fem_p=model->GetFormulation(BalancedthicknessAnalysisEnum);
 
 	//first recover parameters common to all solutions
@@ -48,5 +48,5 @@
 	
 	_printf_("call computational core:\n");
-	diagnostic_core_linear(&h_g,fem_p,inputs,BalancedthicknessAnalysisEnum(),NoneAnalysisEnum());
+	diagnostic_core_linear(&h_g,fem_p,inputs,BalancedthicknessAnalysisEnum,NoneAnalysisEnum);
 
 	_printf_("extrude computed thickness on all layers:\n");
Index: issm/trunk/src/c/parallel/balancedvelocities.cpp
===================================================================
--- issm/trunk/src/c/parallel/balancedvelocities.cpp	(revision 3566)
+++ issm/trunk/src/c/parallel/balancedvelocities.cpp	(revision 3567)
@@ -73,5 +73,5 @@
 
 	_printf_("read and create finite element model:\n");
-	model->AddFormulation(fid,BalancedvelocitiesAnalysisEnum());
+	model->AddFormulation(fid,BalancedvelocitiesAnalysisEnum);
 
 	/*recover parameters: */
@@ -81,7 +81,7 @@
 	_printf_("initialize inputs:\n");
 	
-	model->FindParam(&u_g_serial,NULL,NULL,"u_g",BalancedvelocitiesAnalysisEnum());
-	model->FindParam(&melting_g,NULL,NULL,"m_g",BalancedvelocitiesAnalysisEnum());
-	model->FindParam(&accumulation_g,NULL,NULL,"a_g",BalancedvelocitiesAnalysisEnum());
+	model->FindParam(&u_g_serial,NULL,NULL,"u_g",BalancedvelocitiesAnalysisEnum);
+	model->FindParam(&melting_g,NULL,NULL,"m_g",BalancedvelocitiesAnalysisEnum);
+	model->FindParam(&accumulation_g,NULL,NULL,"a_g",BalancedvelocitiesAnalysisEnum);
 	model->FindParam(&numberofnodes,"numberofnodes");
 	
@@ -92,5 +92,5 @@
 
 	_printf_("initialize results:\n");
-	results=new DataSet(ResultsEnum());
+	results=new DataSet(ResultsEnum);
 	MPI_Barrier(MPI_COMM_WORLD); finish_init=MPI_Wtime();
 
@@ -112,5 +112,5 @@
 		#ifdef _HAVE_DAKOTA_ 
 		MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
-		Qmux(model,inputs,BalancedvelocitiesAnalysisEnum(),NoneAnalysisEnum());
+		Qmux(model,inputs,BalancedvelocitiesAnalysisEnum,NoneAnalysisEnum);
 		MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
 	 	#else
@@ -124,5 +124,5 @@
 	
 	_printf_("process results:\n");
-	ProcessResults(&processedresults,results,model,BalancedvelocitiesAnalysisEnum());
+	ProcessResults(&processedresults,results,model,BalancedvelocitiesAnalysisEnum);
 	
 	_printf_("write results to disk:\n");
Index: issm/trunk/src/c/parallel/balancedvelocities_core.cpp
===================================================================
--- issm/trunk/src/c/parallel/balancedvelocities_core.cpp	(revision 3566)
+++ issm/trunk/src/c/parallel/balancedvelocities_core.cpp	(revision 3567)
@@ -34,5 +34,5 @@
 
 	/*recover fem model: */
-	fem_p=model->GetFormulation(BalancedvelocitiesAnalysisEnum());
+	fem_p=model->GetFormulation(BalancedvelocitiesAnalysisEnum);
 
 	//first recover parameters common to all solutions
@@ -47,5 +47,5 @@
 	
 	_printf_("call computational core:\n");
-	diagnostic_core_linear(&v_g,fem_p,inputs,BalancedvelocitiesAnalysisEnum(),NoneAnalysisEnum());
+	diagnostic_core_linear(&v_g,fem_p,inputs,BalancedvelocitiesAnalysisEnum,NoneAnalysisEnum);
 
 	_printf_("extrude computed thickness on all layers:\n");
Index: issm/trunk/src/c/parallel/control_core.cpp
===================================================================
--- issm/trunk/src/c/parallel/control_core.cpp	(revision 3566)
+++ issm/trunk/src/c/parallel/control_core.cpp	(revision 3567)
@@ -97,5 +97,5 @@
 		 * distribution: */
 		if (control_steady){
-			steadystate_results=new DataSet(ResultsEnum());
+			steadystate_results=new DataSet(ResultsEnum);
 			steadystate_core(steadystate_results,model,inputs);
 			VecFree(&t_g); steadystate_results->FindResult(&t_g,"t_g");
@@ -108,5 +108,5 @@
 
 		_printf_("%s\n","      computing gradJ...");
-		gradjcompute_results=new DataSet(ResultsEnum()); 
+		gradjcompute_results=new DataSet(ResultsEnum); 
 		gradjcompute_core(gradjcompute_results,model, inputs);
 		gradjcompute_results->FindResult(&grad_g,"grad_g");
@@ -205,5 +205,5 @@
 	if (control_steady){
 		inputs->Add(control_type,param_g,1,numberofnodes);
-		steadystate_results=new DataSet(ResultsEnum());
+		steadystate_results=new DataSet(ResultsEnum);
 		steadystate_core(steadystate_results,model,inputs);
 
@@ -216,5 +216,5 @@
 	else{
 		inputs->Add(control_type,param_g,1,numberofnodes);
-		diagnostic_results=new DataSet(ResultsEnum()); 
+		diagnostic_results=new DataSet(ResultsEnum); 
 		diagnostic_core(diagnostic_results,model, inputs);
 
Index: issm/trunk/src/c/parallel/diagnostic.cpp
===================================================================
--- issm/trunk/src/c/parallel/diagnostic.cpp	(revision 3566)
+++ issm/trunk/src/c/parallel/diagnostic.cpp	(revision 3567)
@@ -76,17 +76,17 @@
 	_printf_("read and create finite element model:\n");
 	_printf_("\n   reading diagnostic horiz model data:\n");
-	model->AddFormulation(fid,DiagnosticAnalysisEnum(),HorizAnalysisEnum());
+	model->AddFormulation(fid,DiagnosticAnalysisEnum,HorizAnalysisEnum);
 
 	_printf_("\n   reading diagnostic vert model data:\n");
-	model->AddFormulation(fid,DiagnosticAnalysisEnum(),VertAnalysisEnum());
+	model->AddFormulation(fid,DiagnosticAnalysisEnum,VertAnalysisEnum);
 	
 	_printf_("\n   reading diagnostic stokes model data:\n");
-	model->AddFormulation(fid,DiagnosticAnalysisEnum(),StokesAnalysisEnum());
+	model->AddFormulation(fid,DiagnosticAnalysisEnum,StokesAnalysisEnum);
 	
 	_printf_("\n   reading diagnostic hutter model data:\n");
-	model->AddFormulation(fid,DiagnosticAnalysisEnum(),HutterAnalysisEnum());
+	model->AddFormulation(fid,DiagnosticAnalysisEnum,HutterAnalysisEnum);
 	
 	_printf_("\n   reading surface and bed slope computation model data:\n");
-	model->AddFormulation(fid,SlopecomputeAnalysisEnum());
+	model->AddFormulation(fid,SlopecomputeAnalysisEnum);
 
 	/*get parameters: */
@@ -96,5 +96,5 @@
 
 	_printf_("initialize inputs:\n");
-	model->FindParam(&u_g_initial,NULL,NULL,"u_g",DiagnosticAnalysisEnum(),HorizAnalysisEnum());
+	model->FindParam(&u_g_initial,NULL,NULL,"u_g",DiagnosticAnalysisEnum,HorizAnalysisEnum);
 	model->FindParam(&numberofnodes,"numberofnodes");
 
@@ -103,6 +103,6 @@
 
 	if(control_analysis){
-		model->FindParam(&u_g_obs,NULL,NULL,"u_g_obs",DiagnosticAnalysisEnum(),HorizAnalysisEnum());
-		model->FindParam(&weights,NULL,NULL,"weights",DiagnosticAnalysisEnum(),HorizAnalysisEnum());
+		model->FindParam(&u_g_obs,NULL,NULL,"u_g_obs",DiagnosticAnalysisEnum,HorizAnalysisEnum);
+		model->FindParam(&weights,NULL,NULL,"weights",DiagnosticAnalysisEnum,HorizAnalysisEnum);
 		inputs->Add("velocity_obs",u_g_obs,2,numberofnodes);
 		inputs->Add("weights",weights,1,numberofnodes);
@@ -110,5 +110,5 @@
 	
 	_printf_("initialize results:\n");
-	results=new DataSet(ResultsEnum());
+	results=new DataSet(ResultsEnum);
 	MPI_Barrier(MPI_COMM_WORLD); finish_init=MPI_Wtime();
 
@@ -127,5 +127,5 @@
 			
 			_printf_("process results:\n");
-			ProcessResults(&processed_results,results,model,DiagnosticAnalysisEnum());
+			ProcessResults(&processed_results,results,model,DiagnosticAnalysisEnum);
 		}
 		else{
@@ -145,5 +145,5 @@
 
 			_printf_("process results:\n");
-			ProcessResults(&processed_results,results,model,ControlAnalysisEnum());
+			ProcessResults(&processed_results,results,model,ControlAnalysisEnum);
 		}
 
@@ -157,5 +157,5 @@
 		#ifdef _HAVE_DAKOTA_ 
 		MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
-		Qmux(model,inputs,DiagnosticAnalysisEnum(),NoneAnalysisEnum());
+		Qmux(model,inputs,DiagnosticAnalysisEnum,NoneAnalysisEnum);
 		MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
 	 	#else
Index: issm/trunk/src/c/parallel/diagnostic_core.cpp
===================================================================
--- issm/trunk/src/c/parallel/diagnostic_core.cpp	(revision 3566)
+++ issm/trunk/src/c/parallel/diagnostic_core.cpp	(revision 3567)
@@ -70,9 +70,9 @@
 
 	/*recover fem models: */
-	fem_dh=model->GetFormulation(DiagnosticAnalysisEnum(),HorizAnalysisEnum());
-	fem_dv=model->GetFormulation(DiagnosticAnalysisEnum(),VertAnalysisEnum());
-	fem_ds=model->GetFormulation(DiagnosticAnalysisEnum(),StokesAnalysisEnum());
-	fem_dhu=model->GetFormulation(DiagnosticAnalysisEnum(),HutterAnalysisEnum());
-	fem_sl=model->GetFormulation(SlopecomputeAnalysisEnum());
+	fem_dh=model->GetFormulation(DiagnosticAnalysisEnum,HorizAnalysisEnum);
+	fem_dv=model->GetFormulation(DiagnosticAnalysisEnum,VertAnalysisEnum);
+	fem_ds=model->GetFormulation(DiagnosticAnalysisEnum,StokesAnalysisEnum);
+	fem_dhu=model->GetFormulation(DiagnosticAnalysisEnum,HutterAnalysisEnum);
+	fem_sl=model->GetFormulation(SlopecomputeAnalysisEnum);
 
 	//specific parameters for specific models
@@ -83,5 +83,5 @@
 	//for qmu analysis, be sure the velocity input we are starting from  is the one in the parameters: */
 	if(qmu_analysis){
-		model->FindParam(&u_g_initial,NULL,NULL,"u_g",DiagnosticAnalysisEnum(),HorizAnalysisEnum());
+		model->FindParam(&u_g_initial,NULL,NULL,"u_g",DiagnosticAnalysisEnum,HorizAnalysisEnum);
 		inputs->Add("velocity",u_g_initial,3,numberofnodes);
 	}
@@ -90,6 +90,6 @@
 			
 		if(verbose)_printf_("%s\n","computing surface slope (x and y derivatives)...");
-		diagnostic_core_linear(&slopex,fem_sl,inputs,SlopecomputeAnalysisEnum(),SurfaceXAnalysisEnum());
-		diagnostic_core_linear(&slopey,fem_sl,inputs,SlopecomputeAnalysisEnum(),SurfaceYAnalysisEnum());
+		diagnostic_core_linear(&slopex,fem_sl,inputs,SlopecomputeAnalysisEnum,SurfaceXAnalysisEnum);
+		diagnostic_core_linear(&slopey,fem_sl,inputs,SlopecomputeAnalysisEnum,SurfaceYAnalysisEnum);
 
 		if (dim==3){
@@ -106,8 +106,8 @@
 
 		if(verbose)_printf_("%s\n"," computing hutter velocities...");
-		diagnostic_core_linear(&ug,fem_dhu,inputs,DiagnosticAnalysisEnum(),HutterAnalysisEnum());
+		diagnostic_core_linear(&ug,fem_dhu,inputs,DiagnosticAnalysisEnum,HutterAnalysisEnum);
 
 		if(verbose)_printf_("%s\n"," computing pressure according to MacAyeal...");
-		ComputePressurex(&pg,fem_dhu->elements,fem_dhu->nodes, fem_dhu->vertices,fem_dhu->loads,fem_dhu->materials,fem_dhu->parameters,inputs,DiagnosticAnalysisEnum(),HutterAnalysisEnum());
+		ComputePressurex(&pg,fem_dhu->elements,fem_dhu->nodes, fem_dhu->vertices,fem_dhu->loads,fem_dhu->materials,fem_dhu->parameters,inputs,DiagnosticAnalysisEnum,HutterAnalysisEnum);
 
 		if(verbose)_printf_("%s\n"," update boundary conditions for macyeal pattyn using hutter results...");
@@ -123,9 +123,9 @@
 		
 		if(verbose)_printf_("%s\n"," computing horizontal velocities...");
-		diagnostic_core_nonlinear(&ug,NULL,NULL,fem_dh->loads,fem_dh,inputs,DiagnosticAnalysisEnum(),HorizAnalysisEnum());
+		diagnostic_core_nonlinear(&ug,NULL,NULL,fem_dh->loads,fem_dh,inputs,DiagnosticAnalysisEnum,HorizAnalysisEnum);
 
 		if(dim==2){
 			if(verbose)_printf_("%s\n"," computing pressure according to MacAyeal...");
-			ComputePressurex(&pg,fem_dh->elements,fem_dh->nodes, fem_dh->vertices,fem_dh->loads,fem_dh->materials,fem_dh->parameters,inputs,DiagnosticAnalysisEnum(),HorizAnalysisEnum());
+			ComputePressurex(&pg,fem_dh->elements,fem_dh->nodes, fem_dh->vertices,fem_dh->loads,fem_dh->materials,fem_dh->parameters,inputs,DiagnosticAnalysisEnum,HorizAnalysisEnum);
 		}
 
@@ -140,5 +140,5 @@
 		if(verbose)_printf_("%s\n"," computing vertical velocities...");
 		inputs->Add("velocity",ug_horiz,numberofdofspernode_dh,numberofnodes);
-		diagnostic_core_linear(&ug_vert,fem_dv,inputs,DiagnosticAnalysisEnum(),VertAnalysisEnum());
+		diagnostic_core_linear(&ug_vert,fem_dv,inputs,DiagnosticAnalysisEnum,VertAnalysisEnum);
 
 		if(verbose)_printf_("%s\n"," combining horizontal and vertical velocities...");
@@ -150,5 +150,5 @@
 
 		if(verbose)_printf_("%s\n"," computing pressure according to Pattyn...");
-		ComputePressurex(&pg,fem_dh->elements, fem_dh->nodes, fem_dh->vertices,fem_dh->loads,  fem_dh->materials,fem_dh->parameters,inputs,DiagnosticAnalysisEnum(),HorizAnalysisEnum());
+		ComputePressurex(&pg,fem_dh->elements, fem_dh->nodes, fem_dh->vertices,fem_dh->loads,  fem_dh->materials,fem_dh->parameters,inputs,DiagnosticAnalysisEnum,HorizAnalysisEnum);
 		
 		if (isstokes){
@@ -158,6 +158,6 @@
 
 			if(verbose)_printf_("%s\n","computing bed slope (x and y derivatives)...");
-			diagnostic_core_linear(&slopex,fem_sl,inputs,SlopecomputeAnalysisEnum(),BedXAnalysisEnum());
-			diagnostic_core_linear(&slopey,fem_sl,inputs,SlopecomputeAnalysisEnum(),BedYAnalysisEnum());
+			diagnostic_core_linear(&slopex,fem_sl,inputs,SlopecomputeAnalysisEnum,BedXAnalysisEnum);
+			diagnostic_core_linear(&slopey,fem_sl,inputs,SlopecomputeAnalysisEnum,BedYAnalysisEnum);
 			FieldExtrudex( slopex, fem_sl->elements,fem_sl->nodes,fem_sl->vertices,fem_sl->loads,fem_sl->materials,fem_sl->parameters,"slopex",0);
 			FieldExtrudex( slopey, fem_sl->elements,fem_sl->nodes,fem_sl->vertices,fem_sl->loads,fem_sl->materials,fem_sl->parameters,"slopey",0);
@@ -182,5 +182,5 @@
 			if(verbose)_printf_("%s\n"," computing stokes velocities and pressure ...");
 			VecFree(&ug);
-			diagnostic_core_nonlinear(&ug,NULL,NULL,NULL,fem_ds,inputs,DiagnosticAnalysisEnum(),StokesAnalysisEnum());
+			diagnostic_core_nonlinear(&ug,NULL,NULL,NULL,fem_ds,inputs,DiagnosticAnalysisEnum,StokesAnalysisEnum);
 		
 			//decondition" pressure
Index: issm/trunk/src/c/parallel/gradjcompute_core.cpp
===================================================================
--- issm/trunk/src/c/parallel/gradjcompute_core.cpp	(revision 3566)
+++ issm/trunk/src/c/parallel/gradjcompute_core.cpp	(revision 3567)
@@ -62,5 +62,5 @@
 
 	_printf_("%s\n","      recover solution for this stiffness and right hand side:");
-	diagnostic_core_nonlinear(&u_g,&K_ff0,&K_fs0,NULL, femmodel,inputs,DiagnosticAnalysisEnum(),sub_analysis_type);
+	diagnostic_core_nonlinear(&u_g,&K_ff0,&K_fs0,NULL, femmodel,inputs,DiagnosticAnalysisEnum,sub_analysis_type);
 	VecToMPISerial(&u_g_double,u_g); VecFree(&u_g);
 	inputs->Add("velocity",u_g_double,numberofdofspernode,numberofnodes);
@@ -95,5 +95,5 @@
 
 	if(control_steady){
-		diagnostic_results=new DataSet(ResultsEnum()); 
+		diagnostic_results=new DataSet(ResultsEnum); 
 		diagnostic_core(diagnostic_results,model, inputs);
 
Index: issm/trunk/src/c/parallel/objectivefunctionC.cpp
===================================================================
--- issm/trunk/src/c/parallel/objectivefunctionC.cpp	(revision 3566)
+++ issm/trunk/src/c/parallel/objectivefunctionC.cpp	(revision 3567)
@@ -90,5 +90,5 @@
 	/*Run diagnostic with updated parameters.*/
 	if(!control_steady){
-		diagnostic_core_nonlinear(&u_g,NULL,NULL,NULL,femmodel,inputs,DiagnosticAnalysisEnum(),sub_analysis_type);
+		diagnostic_core_nonlinear(&u_g,NULL,NULL,NULL,femmodel,inputs,DiagnosticAnalysisEnum,sub_analysis_type);
 		VecToMPISerial(&u_g_double,u_g); VecFree(&u_g);
 		inputs->Add("velocity",u_g_double,numberofdofspernode,numberofnodes);
@@ -96,5 +96,5 @@
 	else{
 		//We need a 3D velocity!! (vz is required for the next thermal run)
-		diagnostic_results=new DataSet(ResultsEnum()); 
+		diagnostic_results=new DataSet(ResultsEnum); 
 		diagnostic_core(diagnostic_results,model, inputs);
 
Index: issm/trunk/src/c/parallel/prognostic.cpp
===================================================================
--- issm/trunk/src/c/parallel/prognostic.cpp	(revision 3566)
+++ issm/trunk/src/c/parallel/prognostic.cpp	(revision 3567)
@@ -74,5 +74,5 @@
 
 	_printf_("read and create finite element model:\n");
-	model->AddFormulation(fid,PrognosticAnalysisEnum());
+	model->AddFormulation(fid,PrognosticAnalysisEnum);
 
 	/*recover parameters: */
@@ -82,8 +82,8 @@
 	_printf_("initialize inputs:\n");
 	
-	model->FindParam(&u_g_serial,NULL,NULL,"u_g",PrognosticAnalysisEnum());
-	model->FindParam(&h_g_initial,NULL,NULL,"h_g",PrognosticAnalysisEnum());
-	model->FindParam(&melting_g,NULL,NULL,"m_g",PrognosticAnalysisEnum());
-	model->FindParam(&accumulation_g,NULL,NULL,"a_g",PrognosticAnalysisEnum());
+	model->FindParam(&u_g_serial,NULL,NULL,"u_g",PrognosticAnalysisEnum);
+	model->FindParam(&h_g_initial,NULL,NULL,"h_g",PrognosticAnalysisEnum);
+	model->FindParam(&melting_g,NULL,NULL,"m_g",PrognosticAnalysisEnum);
+	model->FindParam(&accumulation_g,NULL,NULL,"a_g",PrognosticAnalysisEnum);
 	model->FindParam(&dt,"dt");
 	model->FindParam(&yts,"yts");
@@ -98,5 +98,5 @@
 
 	_printf_("initialize results:\n");
-	results=new DataSet(ResultsEnum());
+	results=new DataSet(ResultsEnum);
 	MPI_Barrier(MPI_COMM_WORLD); finish_init=MPI_Wtime();
 
@@ -118,5 +118,5 @@
 		#ifdef _HAVE_DAKOTA_ 
 		MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
-		Qmux(model,inputs,PrognosticAnalysisEnum(),NoneAnalysisEnum());
+		Qmux(model,inputs,PrognosticAnalysisEnum,NoneAnalysisEnum);
 		MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
 	 	#else
@@ -130,5 +130,5 @@
 	
 	_printf_("process results:\n");
-	ProcessResults(&processedresults,results,model,PrognosticAnalysisEnum());
+	ProcessResults(&processedresults,results,model,PrognosticAnalysisEnum);
 	
 	_printf_("write results to disk:\n");
Index: issm/trunk/src/c/parallel/prognostic2.cpp
===================================================================
--- issm/trunk/src/c/parallel/prognostic2.cpp	(revision 3566)
+++ issm/trunk/src/c/parallel/prognostic2.cpp	(revision 3567)
@@ -74,5 +74,5 @@
 
 	_printf_("read and create finite element model:\n");
-	model->AddFormulation(fid,Prognostic2AnalysisEnum());
+	model->AddFormulation(fid,Prognostic2AnalysisEnum);
 
 	/*recover parameters: */
@@ -82,9 +82,9 @@
 	_printf_("initialize inputs:\n");
 	
-	model->FindParam(&vx_g,NULL,NULL,"vx_g",Prognostic2AnalysisEnum());
-	model->FindParam(&vy_g,NULL,NULL,"vy_g",Prognostic2AnalysisEnum());
-	model->FindParam(&h_g_initial,NULL,NULL,"h_g",Prognostic2AnalysisEnum());
-	model->FindParam(&m_g,NULL,NULL,"m_g",Prognostic2AnalysisEnum());
-	model->FindParam(&a_g,NULL,NULL,"a_g",Prognostic2AnalysisEnum());
+	model->FindParam(&vx_g,NULL,NULL,"vx_g",Prognostic2AnalysisEnum);
+	model->FindParam(&vy_g,NULL,NULL,"vy_g",Prognostic2AnalysisEnum);
+	model->FindParam(&h_g_initial,NULL,NULL,"h_g",Prognostic2AnalysisEnum);
+	model->FindParam(&m_g,NULL,NULL,"m_g",Prognostic2AnalysisEnum);
+	model->FindParam(&a_g,NULL,NULL,"a_g",Prognostic2AnalysisEnum);
 	model->FindParam(&dt,"dt");
 	model->FindParam(&yts,"yts");
@@ -100,5 +100,5 @@
 
 	_printf_("initialize results:\n");
-	results=new DataSet(ResultsEnum());
+	results=new DataSet(ResultsEnum);
 	MPI_Barrier(MPI_COMM_WORLD); finish_init=MPI_Wtime();
 
@@ -120,5 +120,5 @@
 		#ifdef _HAVE_DAKOTA_ 
 		MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
-		Qmux(model,inputs,Prognostic2AnalysisEnum(),NoneAnalysisEnum());
+		Qmux(model,inputs,Prognostic2AnalysisEnum,NoneAnalysisEnum);
 		MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
 	 	#else
@@ -132,5 +132,5 @@
 	
 	_printf_("process results:\n");
-	ProcessResults(&processedresults,results,model,Prognostic2AnalysisEnum());
+	ProcessResults(&processedresults,results,model,Prognostic2AnalysisEnum);
 	
 	_printf_("write results to disk:\n");
Index: issm/trunk/src/c/parallel/prognostic2_core.cpp
===================================================================
--- issm/trunk/src/c/parallel/prognostic2_core.cpp	(revision 3566)
+++ issm/trunk/src/c/parallel/prognostic2_core.cpp	(revision 3567)
@@ -35,5 +35,5 @@
 
 	/*recover fem model: */
-	fem_p=model->GetFormulation(Prognostic2AnalysisEnum());
+	fem_p=model->GetFormulation(Prognostic2AnalysisEnum);
 
 	//first recover parameters common to all solutions
@@ -54,5 +54,5 @@
 	
 	_printf_("call computational core:\n");
-	diagnostic_core_linear(&h_g,fem_p,inputs,Prognostic2AnalysisEnum(),NoneAnalysisEnum());
+	diagnostic_core_linear(&h_g,fem_p,inputs,Prognostic2AnalysisEnum,NoneAnalysisEnum);
 
 	_printf_("Averaging over vertices:\n");
Index: issm/trunk/src/c/parallel/prognostic_core.cpp
===================================================================
--- issm/trunk/src/c/parallel/prognostic_core.cpp	(revision 3566)
+++ issm/trunk/src/c/parallel/prognostic_core.cpp	(revision 3567)
@@ -34,5 +34,5 @@
 
 	/*recover fem model: */
-	fem_p=model->GetFormulation(PrognosticAnalysisEnum());
+	fem_p=model->GetFormulation(PrognosticAnalysisEnum);
 
 	//first recover parameters common to all solutions
@@ -47,5 +47,5 @@
 	
 	_printf_("call computational core:\n");
-	diagnostic_core_linear(&h_g,fem_p,inputs,PrognosticAnalysisEnum(),NoneAnalysisEnum());
+	diagnostic_core_linear(&h_g,fem_p,inputs,PrognosticAnalysisEnum,NoneAnalysisEnum);
 
 	_printf_("extrude computed thickness on all layers:\n");
Index: issm/trunk/src/c/parallel/slopecompute.cpp
===================================================================
--- issm/trunk/src/c/parallel/slopecompute.cpp	(revision 3566)
+++ issm/trunk/src/c/parallel/slopecompute.cpp	(revision 3567)
@@ -68,5 +68,5 @@
 
 	_printf_("read and create finite element model:\n");
-	model->AddFormulation(fid,SlopecomputeAnalysisEnum());
+	model->AddFormulation(fid,SlopecomputeAnalysisEnum);
 
 	/*recover parameters: */
@@ -80,5 +80,5 @@
 
 	_printf_("initialize results:\n");
-	results=new DataSet(ResultsEnum());
+	results=new DataSet(ResultsEnum);
 	MPI_Barrier(MPI_COMM_WORLD); finish_init=MPI_Wtime();
 
@@ -94,5 +94,5 @@
 	
 	_printf_("process results:\n");
-	ProcessResults(&processedresults,results,model,SlopecomputeAnalysisEnum());
+	ProcessResults(&processedresults,results,model,SlopecomputeAnalysisEnum);
 	
 	_printf_("write results to disk:\n");
Index: issm/trunk/src/c/parallel/slopecompute_core.cpp
===================================================================
--- issm/trunk/src/c/parallel/slopecompute_core.cpp	(revision 3566)
+++ issm/trunk/src/c/parallel/slopecompute_core.cpp	(revision 3567)
@@ -31,5 +31,5 @@
 
 	/*recover fem model: */
-	fem_sl=model->GetFormulation(SlopecomputeAnalysisEnum());
+	fem_sl=model->GetFormulation(SlopecomputeAnalysisEnum);
 
 	//first recover parameters common to all solutions
@@ -39,6 +39,6 @@
 
 	_printf_("call computational core:\n");
-	diagnostic_core_linear(&sx_g,fem_sl,inputs,SlopecomputeAnalysisEnum(),SurfaceXAnalysisEnum());
-	diagnostic_core_linear(&sy_g,fem_sl,inputs,SlopecomputeAnalysisEnum(),SurfaceYAnalysisEnum());
+	diagnostic_core_linear(&sx_g,fem_sl,inputs,SlopecomputeAnalysisEnum,SurfaceXAnalysisEnum);
+	diagnostic_core_linear(&sy_g,fem_sl,inputs,SlopecomputeAnalysisEnum,SurfaceYAnalysisEnum);
 
 	_printf_("extrude computed slope on all layers:\n");
